//---------- Functions to call when you only have a VisibleObject* -------

Vector ObjectNormal(VisibleObject *O,Point *P)
{
  switch (O->Type)
  {
    case OBJECT_SPHERE:
	    return SphereNormal((Sphere*)O, P);
    case OBJECT_PLANE:
	    return PlaneNormal((Plane*)O, P);
  }
	{ // Stop "Function should return a value" warning.
  	Vector Temp = {0,0,0};
  	return Temp;
	}
}

void ObjectGetPixel(VisibleObject *O,Point *P,Color *C)
{

  switch (O->Type)
  {
    case OBJECT_SPHERE:
	   *C = O->OpticalProperty.Col;
	   break;
    case OBJECT_PLANE:
       PlaneGetPixel((Plane*)O, P, C);
	   break;
  }
}

bool ObjectIntersect(VisibleObject *O,void *R)
{
  switch (O->Type)
  {
    case OBJECT_SPHERE:
	    return SphereIntersect((Sphere*)O, (Ray*)R);
    case OBJECT_PLANE:
		return PlaneIntersect((Plane*)O, (Ray*)R);
  }
  return 0;
}

void *ObjectCreateShader(VisibleObject *O,void *R)
{
  switch (O->Type)
  {
    case OBJECT_SPHERE:
	    return SphereCreateShader((Sphere*)O, (Ray*)R);
    case OBJECT_PLANE:
		return PlaneCreateShader((Plane*)O, (Ray*)R);
  }
  return NULL;
}
