#if !defined OBJECT_H
#define OBJECT_H
//------------------------------------
//  (c) Reliable Software, 1996, 97
//------------------------------------

// Optical properties of a VisibleObject
typedef struct{
  Color  Col;

  double Refractiveness; // Coefficient of refraction
  double Transparency;   // Transparency
  double Reflectiveness; // Reflection
  double Diffusion;      // Diffuse coeff

  bool   IsLuminous;
}OpticalProp;

// Common to all objects
typedef struct{
  int Type;
  OpticalProp OpticalProperty;
}VisibleObject;

Vector ObjectNormal(VisibleObject *,Point *);
void ObjectGetPixel(VisibleObject *,Point *,Color *);
bool ObjectIntersect(VisibleObject *,void *);
void *ObjectCreateShader(VisibleObject *,void *);

//
//-------------------- SPHERE ---------------------
//
#define OBJECT_SPHERE 1

typedef struct{
  VisibleObject Obj;
  Point  Center;
  double Radius;
  double R2; // Radius square
}Sphere;

//
//-------------------- PLANE ---------------------
//
#define OBJECT_PLANE 2

typedef struct{
  VisibleObject Obj;
  Point  Center;
  Vector Normal;

  // The tile
  COLORREF *Pixels;
  int       Width;
  int       Height;

  double    Cos_inv;
}Plane;

#endif
