#if !defined RAY_H
#define RAY_H
//------------------------------------
//  (c) Reliable Software, 1996, 97
//------------------------------------
const double HUGE_DIST = 1000000.0;

typedef enum{ rtNormal = 1,rtRefracted,rtShadow }RayType;

typedef struct{
  RayType Type;
  Point Origin;
  Vector Direction;
  int Depth;
  double Dist;
  VisibleObject *Obj;

  //For rtRefacted
  double Refr;

  //For rtShadow
  double Attenuation; // Attenuation when passing through transparent objects
}Ray,*LPRAY;

void RaySet(Ray *,RayType,Point *,Vector *,int,double);
void RayHit(Ray *,Color *);
Point RayIntersect(Ray *);
void RayRecord(Ray *,double,VisibleObject *);
void RayDoShade(Ray *,Color *);

#endif
