#if !defined SHADER_H
#define SHADER_H
//------------------------------------
//  (c) Reliable Software, 1996, 97
//------------------------------------
#define SHADER_PHONG 1

// Plane Shader - Creates stripes
#define SHADER_PLANE 2

typedef struct{
  int Type;
  Ray *IncidentRay;
  OpticalProp *Prop;
  int Depth;

  // Secondary rays
  Ray *ReflectedRay;
  Ray *RefractedRay;
  Ray *ShadowRay;

  // Geometry
  Point  Intersect;
  Vector Normal;
  double Cosine;
  double Light_cos;

  // Plane shader only
  Color Pixel;
}Shader;

void ShaderSet(Shader*,int,Ray*,VisibleObject*);
void ShaderGetColor(Shader*,Color*);
Vector ShaderReflect(Shader*);
Vector ShaderRefract(Shader*);
void ShaderFree(Shader*);

#endif
